dpkg (1.23.7ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
    - dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
      environment if not already set.  This setting is picked up by
      GCC and clang, passing a --package-metadata option the the linker.
    - Stop passing --specs for metadata information. It's too fragile
      and only works for GCC. Also introduces a lot of packaging delta.
    - Stop defaulting to -O3 on amd64.
    - dpkg-dev: Still prefer gnupg and gpgv over sq.
     Introduce architecture variants (thanks to mwhudson for the rebase)
    - scripts/dpkg-gencentrol.pl: fix operator precedence.
    - Copy across the architecture variant (LP #2128606)
    - Drop unused elf-package-metadata specs files
    - dpkg-buildflags: set --package-metadata directly in LDFLAGS, and still
      set ELF_PACKAGE_METADATA in the environment.
    - Include architecture variant in ELF package metadata (LP #2131806)
    - Set a derivative.ubuntu build profile by default.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 31 Mar 2026 16:52:44 +0200

dpkg (1.23.7) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-deb: Remove ancient code to handle buggy old .deb format variants.
  * Perl modules:
    - Dpkg::Source::Package::V1: Do not print source root on modified files
      list.
    - Dpkg::Source::Package::V1: Fix building from within the source tree.

 -- Guillem Jover <guillem@debian.org>  Sat, 07 Mar 2026 00:41:13 +0100

dpkg (1.23.6ubuntu2) resolute; urgency=medium

  * Set a derivative.ubuntu build profile by default.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 14 Mar 2026 17:10:34 +0100

dpkg (1.23.6ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
    - dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
      environment if not already set.  This setting is picked up by
      GCC and clang, passing a --package-metadata option the the linker.
    - Stop passing --specs for metadata information. It's too fragile
      and only works for GCC. Also introduces a lot of packaging delta.
    - Stop defaulting to -O3 on amd64.
    - dpkg-dev: Still prefer gnupg and gpgv over sq.
     Introduce architecture variants (thanks to mwhudson for the rebase)
    - scripts/dpkg-gencentrol.pl: fix operator precedence.
    - Copy across the architecture variant (LP #2128606)
    - Drop unused elf-package-metadata specs files
    - dpkg-buildflags: set --package-metadata directly in LDFLAGS, and still
      set ELF_PACKAGE_METADATA in the environment.
    - Include architecture variant in ELF package metadata (LP #2131806)

 -- Matthias Klose <doko@ubuntu.com>  Sat, 07 Mar 2026 08:47:21 +0100

dpkg (1.23.6) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-query: Fix segfault with empty -S argument. LP: #2092676
  * dpkg-deb: Be more robust against truncated ar archives.
    Reported by Yashashree Gund <yash_gund@live.com>.
  * dpkg-deb: Reject ar archives with 0 sized tar members.
    Reported by Yashashree Gund <yash_gund@live.com>.
  * libdpkg, scripts: Detect corrupt ar archive with non-even byte sizes.
  * dpkg-source: Fix running from within the source tree.
    Reported by Umut <ue16@gmx.de> (on IRC).
  * dpkg-source: Support running --commit from within the source tree w/o
    «.». Closes: #1127383
  * dpkg-source: Fix format in maintainer error message.
    Thanks to Marko Zajc <marko@zajc.tel>.
  * dpkg-scanpackages: Add new --no-implicit-arch option. Closes: #1128325
  * Perl modules:
    - Dpkg::Shlibs::Objdump::Object: Clarify code comment.
    - Dpkg::Source::Package::V2: Do not print source root on modified files
      list. Closes: #1126558
    - Dpkg::Source::Patch: Speed up patched filename retrieval in patches.
    - Dpkg::Source::Patch: Add comment about the use of tr{}{} as char counter.
    - Dpkg::OpenPGP::Backend::GnuPG: Add missing Dpkg::Gettext import.
      Closes: #1128406
    - Dpkg::OpenPGP::Backend::GnuPG: Refactor _file_read_header().
    - Dpkg::OpenPGP::Backend::GnuPG: Detect and warn on LibrePGP artifacts.
    - Dpkg::Email::Address: Warn on email domains with a single label.
      Closes: #1126508
    - Dpkg::Source::Patch: Fix code comment.
    - Dpkg::Source::Patch: Add new has_errors() method.
    - Dpkg::Source::Package::V2: Delay unrepresentable error after local
      changes list. Closes: #1126665
    - Dpkg::Vendor: Fix taint mode in get_vendor_object().
    - Dpkg::Compression: Remove deprecated function compression_get_property().
    - Dpkg::Archive::Ar: Switch header variables into a hash.
    - Dpkg::Archive::Ar: Check that no header field is empty.
  * Code internals:
    - libdpkg: Use varbuf_str() instead of directly accessing buf.
    - scripts: Parse and validate all Changed-By and Maintainer field inputs.
      Closes: #1126507
    - libdpkg: Terminate zstd decompression when we have no more data.
      Reported by Yashashree Gund <yash_gund@live.com>. Closes: #1129722
      Fixes CVE-2026-2219.
    - dpkg-deb: Refactor ar member size into an intermediate variable.
  * Build system:
    - Add URL, Maintainer and License fields to .pc file.
  * Test suite:
    - Add basic Perl taint mode checks.
  * Localization:
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1127882, #1127884
    - Update Swedish translations.
      Thanks to Peter Krefting <peter@softwolves.pp.se>. Closes: #1128529

 -- Guillem Jover <guillem@debian.org>  Thu, 05 Mar 2026 06:54:58 +0100

dpkg (1.23.5ubuntu1) resolute; urgency=medium

  * Merge with Debian; remaining changes:
    - Change native source version/format mismatch errors into warnings
      until the dust settles on Debian bug 737634 about override options.
    - Add DPKG_UNTRANSLATED_MESSAGES environment check so that higher-level
      tools can get untranslated dpkg terminal log messages while at the
      same time having translated debconf prompts.
    - Map unqualified package names of multiarch-same packages to the native
      arch instead of throwing an error, so that we don't break on upgrade
      when there are unqualified names stored in the dpkg trigger database.
    - Apply a workaround from mvo to consider ^rc packages as multiarch,
      during the dpkg consistency checks. (see LP: 1015567 and 1057367).
    - dpkg-gencontrol: Fix Package-Type override handling for ddeb support.
    - scripts/Dpkg/Vendor/Ubuntu.pm, scripts/dpkg-buildpackage.pl: set
      'nocheck' in build options by default on Ubuntu/riscv64.  Overridable
      in debian/rules with
      'DEB_BUILD_OPTIONS := $(filter-out nocheck,$(DEB_BUILD_OPTIONS))'.
    - dpkg-dev: Depend on lto-disabled-list.
    - dpkg-buildflags: Read package source names from lto-disabled-list,
      to build without lto optimizations. When adding a source package to the
      list, please also file a launchpad issue and tag it with 'lto'.
    - scripts/Dpkg/Vendor/Ubuntu.pm: set 'noudeb' build profile by
      default. Override this by exporting DEB_BUILD_PROFILE='!noudeb' which
      will be stripped, and thus building with udebs.
    - build: Switch default dpkg-deb compression from xz to zstd.
      Keep compressing dpkg.deb with xz to help bootstrapping on non-Ubuntu
      systems.
    - set default zstd compression level to 19
    - scripts/Dpkg/Vendor/Debian.pm: Always include "-fdebug-prefix-map"
      to build flags.  Map path to "/usr/src/PKGNAME-PKGVER" instead of
      ".", honouring the DWARF standard which prohibits relative paths
      in DW_AT_comp_dir.
    - scripts/{mk/buildflags.mk,t.mk}: Add support for DEB_BUILD_DEBUGPATH.
    - man/dpkg-buildflags.pod: Document new behaviour of "fdebugmap" and
      new DEB_BUILD_DEBUGPATH variable.
    - Disable -fstack-clash-protection on armhf since it causes crashes
    - dpkg-buildflags: Add a new feature "framepointer" in the "qa" area.
    - Turn on the use of frame pointers by default on 64bit architectures.
    - Update _FORTIFY_SOURCE documentation.
    - Update Dpkg_BuildFlags test case.
    - Fix debian/rules duplicate invocations of dh_builddeb
    - lib/dpkg/compress.c: clean up override of the default zstd compression
      level
    - dpkg-buildflags: Explicitly turn off hardening flags when requested.
    - Export environment variables DEB_BUILD_OS_RELEASE_ID, DEB_HOST_ARCH,
      DEB_SOURCE, and DEB_VERSION when including buildflags.mk (LP: #2070015)
    - buildflags: document RUSTFLAGS
    - buildflags: Always set RUSTFLAGS
    - tests: avoid failing under DEB_VENDOR != Debian
    - dpkg-buildflags: enable ELF package note metadata
    - buildflags: set origin of env vars for ELF package metadata
    - Export ELF_PACKAGE_METADATA for a build. Picked up by GCC and clang.
      Passing -specs explicitly can be dropped in a follow-up upload.
    - dpkg-buildflags: set RUSTFLAGS to influence the command line flags cargo
      will pass to rustc, and set the flags to include framepointers when the
      framepointer feature of the qa area is enabled.
    - Disable framepointer on ppc64el.
    - Disable framepointer on s390x, leaving only -mbackchain.
    - Add a note about different behaviour of dpkg-buildflags with respect to
      LTO on Ubuntu.
    - dpkg-buildpackage: Construct ELF_PACKAGE_METADATA, and set in the
      environment if not already set.  This setting is picked up by
      GCC and clang, passing a --package-metadata option the the linker.
    - Stop passing --specs for metadata information. It's too fragile
      and only works for GCC. Also introduces a lot of packaging delta.
    - Stop defaulting to -O3 on amd64.
    - dpkg-dev: Still prefer gnupg and gpgv over sq.
     Introduce architecture variants (thanks to mwhudson for the rebase)
    - scripts/dpkg-gencentrol.pl: fix operator precedence.
    - Copy across the architecture variant (LP #2128606)
    - Drop unused elf-package-metadata specs files
    - dpkg-buildflags: set --package-metadata directly in LDFLAGS, and still
      set ELF_PACKAGE_METADATA in the environment.
    - Include architecture variant in ELF package metadata (LP #2131806)

 -- Matthias Klose <doko@ubuntu.com>  Sun, 08 Feb 2026 12:01:45 +0100

dpkg (1.23.5) unstable; urgency=medium

  [ Guillem Jover ]
  * dpkg-source: Do not error out on empty fields. Closes: #1125985
  * Perl modules:
    - Dpkg::Email::Address: Do not construct invalid objects.
    - Dpkg::Control::FieldsCore: Improve Maintainer and Uploader field parse
      errors.
  * Documentation:
    - man: Improve dpkg-buildpackage --sign-backend description.
  * Build system:
    - Move the dist artifacts to the release directory.
  * Test suite:
    - Add known exception sources for ProhibitCaptureWithoutTest.

 -- Guillem Jover <guillem@debian.org>  Fri, 23 Jan 2026 01:41:44 +0100

dpkg (1.23.4) unstable; urgency=medium

  [ Guillem Jover ]
  * Revert "Dpkg::Vendor: Add branch hardening flags to LDFLAGS".
    Closes: #1125323, #1125715
  * start-stop-daemon: Check for invalid combinations of --notify-await
    options. Closes: #1124643
  * dpkg: Fix typo for «metadata» in error message. Closes: #1125128
  * scripts: Parse and validate Maintainer and Uploaders email addresses.
  * dpkg-source: Warn when the Uploaders field contains the Maintainer.
  * Perl modules:
    - Dpkg::BuildProfiles: Remove the parser workaround now that dh-exec is
      fixed.
    - Dpkg::Shlibs::Symbol: Emit a warning for the deprecated wildcard syntax.
      Closes: #1125722
    - Dpkg::Source::Package::V2: Switch generated patch to be git formatted.
    - Dpkg::Source::Package::V2: Print Bug-<Vendor> in patch template instead
      of vendor specific ones.
    - Dpkg::Email::Address: New module.
    - Dpkg::Control::FieldsCore: Add new email address field parsing functions.
    - Dpkg::Shlibs::SymbolFile: Refactor metavariable substitution into a
      function.
    - Dpkg::Shlibs::SymbolFile: Add support for #CURVER#. Closes: #615940
  * Documentation:
    - dpkg-buildflags(1): Clarify that LDFLAGS are not safe for direct ld(1)
      use. See #1125323.
    - start-stop-daemon(8): Clarify relationship between --notify-await and
      --background. See #1124643.
    - man: Refactor explanation about deb-symbols metavariables.
  * Code internals:
    - dselect: Mark keybindings methods only accessing static members as
      static.
    - dpkg-deb: Reduce pid variable scope.
    - libcompat: Define __has_attribute() if not already defined in gettext.h.
  * Packaging:
    - Bump Standards-Version to 4.7.3 (no changes needed).
  * Test suite:
    - Undefine _LIBC for cppcheck.
    - Update cppcheck suppressions for 2.19.0.
  * Localization:
    - Update Dutch translations.
      Thanks to Frans Spiesschaert <Frans.Spiesschaert@yucom.be>.
      Closes: #1125463, #1125465, #1125466
    - Update Portuguese translations.
      Thanks to Américo Monteiro <a_monteiro@gmx.com>.
      Closes: #1124138, #1124412, #1124439, #1124636

 -- Guillem Jover <guillem@debian.org>  Sun, 18 Jan 2026 18:29:23 +0100

dpkg (1.23.3) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::Vendor::Debian: Mask PIE on m68k, sh4 and x32.
      Thanks to Adrian Bunk <bunk@debian.org>. Closes: #1100187
    - Dpkg::Version: Add new has_epoch() and has_revision() methods.
      Closes: #1123630
    - Dpkg::Source::Package::V1: Make debian/rules executable on extract if
      present. Closes: #1123652

 -- Guillem Jover <guillem@debian.org>  Sat, 20 Dec 2025 02:18:49 +0100

dpkg (1.23.2) unstable; urgency=medium

  [ Guillem Jover ]
  * Perl modules:
    - Dpkg::BuildProfiles: Add workaround for callers passing invalid formulas.
      Diagnosed by Chris Hofstaedtler <zeha@debian.org>.

 -- Guillem Jover <guillem@debian.org>  Thu, 18 Dec 2025 02:10:10 +0100

# For older changelog entries, run 'apt-get changelog dselect'
